<script lang="ts">
    import { createEventDispatcher } from 'svelte'
    export let numberOfQuestions: number
    export let timePerQuestion: number
    export let tables: Set<number>
    const dispatch = createEventDispatcher()

    function dispatchNewSettings () {
      const params = { numberOfQuestions, timePerQuestion, tables: Array.from(tables) }
      const url = new URL(window.location.href)
      url.searchParams.set('params', JSON.stringify(params))
      window.history.replaceState({}, '', url.toString())
      dispatch('settingsHasChanged', {
        numberOfQuestions,
        timePerQuestion,
        tables
      })
    }

    function addOrRemoveTable (event: Event) {
      const checkbox = event.target as HTMLInputElement
      const table = parseInt(checkbox.value)
      if (checkbox.checked) {
        tables.add(table)
      } else {
        tables.delete(table)
      }
      dispatchNewSettings()
    }

</script>

<div class="my-5 flex flex-row flex-wrap gap-4">
    <div class="basis-36">
      <h1>Nombre de questions</h1>

      <form on:change={dispatchNewSettings}>
        <div>
          <label>
            <input type="radio" bind:group={numberOfQuestions} value={5} />
            Cinq questions
          </label>
        </div>
        <div>
          <label>
            <input type="radio" bind:group={numberOfQuestions} value={10} />
            Dix questions
          </label>
        </div>
        <div>
          <label>
            <input type="radio" bind:group={numberOfQuestions} value={20} />
            Vingt questions
          </label>
        </div>
      </form>
    </div>
    <div class="basis-36">
      <h1>Temps par question</h1>
      <input type="number" min="1" max="60" step="1" class="w-24 h-10 px-2 border-2 rounded-md" bind:value={timePerQuestion} on:change={dispatchNewSettings} />
    </div>
    <div>
      <h1>Choix des tables</h1>
      <form on:change={dispatchNewSettings} class="flex flex-wrap">
        {#each [2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13] as table}
          <label class="w-1/3">
            <input type="checkbox"
              value={table}
              checked={tables.has(table)}
              disabled={tables.size === 1 && tables.has(table)}
              on:change={addOrRemoveTable}
            />
            {table}
          </label>
        {/each}
      </form>
    </div>
  </div>

  <style>
    :global(h1) {
    @apply text-xl;
    @apply text-[#216D9A];
    @apply font-bold;
  }
  </style>
